--[[
################################################################
#
#	Hunter Cookies by Mosphet <Inner Sanctum> @ Silvermoon EU
#	Dude I need for use! WTF PRIST!
#
################################################################
]]
local _, class = UnitClass("player")
if class == "HUNTER" then 
	local enable = true
else
	return 
end

local addon = LibStub("AceAddon-3.0"):NewAddon("MosphetCookies", "AceConsole-3.0", "AceEvent-3.0", "AceTimer-3.0")
_G.MosphetCookies = addon
addon.version = tonumber(("$Revision: 51 $"):match("%d+"))
addon.callbacks = LibStub("CallbackHandler-1.0"):New(addon)
addon.media = LibStub("LibSharedMedia-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("MosphetCookies")

-- -----------------
--  Locals
-- -----------------
local _G, type, tonumber, tostring = _G, type, tonumber, tostring;
local tinsert = tinsert;
local format, strsub, strfind, gsub = format, string.sub, string.find, string.gsub;
local ipairs = ipairs;
local rawget,unpack = rawget,unpack;
local GetSpellInfo, GetTalentTabInfo, GetPrimaryTalentTree, GetCombatRating, GetRangedHaste, GetTime = _G.GetSpellInfo, _G.GetTalentTabInfo, _G.GetPrimaryTalentTree, _G.GetCombatRating, _G.GetRangedHaste, _G.GetTime;
local UnitClass, UnitAttackPower, UnitAura =  _G.UnitClass, _G.UnitAttackPower, _G.UnitAura;
local UIParent = _G.UIParent;
local db, combat, talents, debug, refreshcast, talentID;

local defaults = {
	profile = {
		-- -------------
		-- General
		-- -------------
		enabled = true,
		fontface = "Lucidia Sans",
		fontsize = 14,
		justification = "RIGHT",
		fontstyle = "OUTLINE",
		-- -------------
		-- Displays
		-- -------------
		aimed = true,
		steady = true,
		cobra = true,
		hastev = nil,
		hastep = nil,
		petap = nil,
		rabid = nil,
		-- -------------
		-- Thresholds
		-- -------------
		aisthreshenabled = true,
		aisthresh = 1.7,
		aisthreshgt = {1,0,0,1},
		aisthreshlt = {0,1,0,1},
		ssthreshenabled = nil,
		ssthresh = 1.0,
		ssthreshgt = {1,0,0,1},
		ssthreshlt = {0,1,0,1},
		costhreshenabled = nil,
		costhresh = 1.0,
		costhreshgt = {1,0,0,1},
		costhreshlt = {0,1,0,1},
		rpthreshenabled = nil,
		rpthresh = 5,
		rpthreshgt = {0,1,0,1},
		rpthreshlt = {1,0,0,1},
		-- -------------
		-- Positions
		-- -------------
		xOfs = 0,
		yOfs = 0,
		-- -------------
		-- Refresh
		-- -------------
		refresh = 1.0,
	},
}

do
	local embeds = {
		L = L,
		SM = SM,
	}
	for i,v in pairs(embeds) do addon[i] = v end
end

-- -----------------
--  Derps
-- -----------------
function addon:print(msg)
	DEFAULT_CHAT_FRAME:AddMessage("|cFFFFCC00[MC]|r "..msg)
end

function addon:debug(msg)
	if(debug) then
		DEFAULT_CHAT_FRAME:AddMessage("|cFFFFCC00[MC Debug]|r "..msg)
	end
end

function addon:OnInitialize()
	self.db = LibStub("AceDB-3.0"):New("MosphetCookiesDB", defaults, "Default")
	db = self.db.profile
	
	if not self.Awsumness then
		self:CreateAwsumness()
	end
	
	self:RegisterChatCommand("mc", "SlashHandler");	
	self:RegisterChatCommand("cookies", "SlashHandler");
end
	
function addon:OnEnable()
	self:RegisterEvent("PLAYER_REGEN_DISABLED", "EnteringCombat")
	self:RegisterEvent("PLAYER_REGEN_ENABLED", "LeftCombat")
	self:RegisterEvent("PLAYER_ENTERING_WORLD", "UpdateCast");
	self:RegisterEvent("PLAYER_ENTERING_WORLD", "TalentCheck");
	self:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED", "TalentCheck");
end

function addon:OnDisabled()
	self:UnregisterEvent("PLAYER_REGEN_DISABLED")
	self:UnregisterEvent("PLAYER_REGEN_ENABLED")
	self:UnregisterEvent("PLAYER_ENTERING_WORLD");
	self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	self:UnregisterEvent("ACTIVE_TALENT_GROUP_CHANGED");
end

function addon:TalentCheck()
	if not GetTalentTabInfo(1) then
		talents = L["Talents not loaded yet"]
		return
	end

	local specID = GetPrimaryTalentTree()
	if specID then
		local talentsID, specName = GetTalentTabInfo(specID)
		self:debug(string.format("%s %s", specName, UnitClass("player")))
		talents = specName
		talentID = talentsID
	else
		self:debug(L["Unable to detect spec"])
	end
end

function addon:EnteringCombat()
	addon:TalentCheck()
	combat = true
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED", "UpdateCast");
	refreshcast = GetTime();
	self:debug("Entering Combat");
	self:debug("var refreshcast: "..refreshcast);
	self:debug("var talents id: "..talents);
end

function addon:LeftCombat()
	combat = false
	self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
	self:debug("Left Combat");
end

function addon:UpdateCast()
	local refreshrate = db.refresh
	local line1, line2, line3, line4, line5, line6 = "", "", "", "", "", "";
	if refreshcast > GetTime() then return end
	self:debug("UpdateCast");
	if talentID == 807 then
		if db.aimed then
			local _, _, _, _, _, _, castTime = GetSpellInfo(19434);
			local aimed = castTime/1000
			if db.aisthreshenabled then
				if aimed <= db.aisthresh then
					line1 = format("|cff%02x%02x%02xAiS: "..aimed.."|r\n", db.aisthreshlt[1]*255, db.aisthreshlt[2]*255, db.aisthreshlt[3]*255);
				else
					line1 = format("|cff%02x%02x%02xAiS: "..aimed.."|r\n", db.aisthreshgt[1]*255, db.aisthreshgt[2]*255, db.aisthreshgt[3]*255);
				end
			else
				line1 = "AiS: "..aimed.."\n";
			end
		end
		if db.steady then
			local _, _, _, _, _, _, castTime = GetSpellInfo(56641);
			local steady = castTime/1000
			if db.ssthreshenabled then
				if steady <= db.ssthresh then
					line2 = format("|cff%02x%02x%02xSS: "..steady.."|r\n", db.ssthreshlt[1]*255, db.ssthreshlt[2]*255, db.ssthreshlt[3]*255);
				else
					line2 = format("|cff%02x%02x%02xSS: "..steady.."|r\n", db.ssthreshgt[1]*255, db.ssthreshgt[2]*255, db.ssthreshgt[3]*255);
				end
			else
				line2 = "SS: "..steady.."\n";
			end
		end
	else
		if db.cobra then
			local _, _, _, _, _, _, castTime = GetSpellInfo(77767);
			local cobra = castTime/1000
			if db.costhreshenabled then
				if cobra <= db.costhresh then
					line1 = format("|cff%02x%02x%02xCoS: "..cobra.."|r\n", db.costhreshlt[1]*255, db.costhreshlt[2]*255, db.costhreshlt[3]*255);
				else
					line1 = format("|cff%02x%02x%02xCoS: "..cobra.."|r\n", db.costhreshgt[1]*255, db.costhreshgt[2]*255, db.costhreshgt[3]*255);
				end
			else
				line1 = "CoS: "..cobra.."\n";
			end
		end
	end
	if db.hastev then
		local rating = GetCombatRating(CR_HASTE_RANGED);
		line3 = L["Haste"]..": "..rating.."\n";
	end
	if db.hastep then
		local percent = GetRangedHaste();
		line4 = L["Haste"]..": "..format("%.2F%%", percent).."\n";
	end
	if db.petap then
		local base, posBuff, negBuff = UnitAttackPower("pet");
		local petap = base+posBuff+negBuff;
		line5 = "Pet AP: "..petap.."\n";
	end
	if db.rabid then
		local _, _, _, count = UnitAura("pet", 53403);
		if not count then
			count = 0
		end
		if db.rpthreshenabled then
			if count < db.rpthresh then
				line6 = format("|cff%02x%02x%02x"..L["Rabid"]..": "..count.."\n", db.rpthreshlt[1]*255, db.rpthreshlt[2]*255, db.rpthreshlt[3]*255);
			else
				line6 = format("|cff%02x%02x%02x"..L["Rabid"]..": "..count.."\n", db.rpthreshgt[1]*255, db.rpthreshgt[2]*255, db.rpthreshgt[3]*255);
			end
		else
			line6 = L["Rabid"]..": "..count.."\n";
		end
	end
	MosphetCookies.CenterText:AddMessage(line1..line2..line3..line4..line5..line6);
	refreshcast = GetTime() + refreshrate
end

function addon:UpdateJustification(v)
	MosphetCookies.CenterText:SetJustifyH(v);
end

function addon:UpdateFont()
	local fontface = self.media:Fetch("font",db.fontface)
	local fontsize = db.fontsize
	local fontstyle = db.fontstyle
	MosphetCookies.CenterText:SetSize(200,db.fontsize+5)
	MosphetCookies.CenterText:SetFont(fontface, fontsize, fontstyle.." MONOCHROME")
end

-- Gief frame plz ;o
function addon:CreateAwsumness()
	do
		local anchor = CreateFrame("Frame", nil, UIParent)
		anchor:SetSize(200, 15)
		anchor:ClearAllPoints()
		anchor:SetPoint("CENTER", UIParent, "CENTER", db.xOfs, db.yOfs)
		anchor:SetFrameStrata("LOW")
		anchor:SetBackdrop({bgFile = "Interface\\Buttons\\WHITE8X8",
		insets = {left = 0,right = 0,top = 0,bottom = 0}});
		anchor:SetBackdropColor(0, 0, 0, .5)
		anchor:EnableMouse(true)
		anchor:SetScript("OnLeave", function(self)
			-- save pos
			local _, _, _, xOfs, yOfs = self:GetPoint()
			db.xOfs = xOfs
			db.yOfs = yOfs
		end)
		
		anchor.tr = anchor:CreateTitleRegion()
		anchor.tr:SetAllPoints(anchor)
		
		local fontface = self.media:Fetch("font",db.fontface)
		
		local mf = CreateFrame("MessageFrame", "MosphetCookies", UIParent)
		mf:SetSize(200,db.fontsize+5)
		mf:ClearAllPoints()
		mf:SetPoint("TOP", anchor, "TOP", 0, -16)
		mf:Show()
		mf:SetFont(fontface, db.fontsize, db.fontstyle.." MONOCHROME")
		mf:SetShadowOffset(0, 0)
		mf:SetJustifyH(db.justification)
		mf:SetJustifyV("TOP")
		mf:SetTimeVisible(2)
		mf:SetFadeDuration(.5)
		
		mf.anchor = anchor
		
		mf.anchor:Hide()
		MosphetCookies.CenterText = mf;
	end
end

function addon:ResetAnchor()
	db.xOfs = 0
	db.yOfs = 0
	MosphetCookies.anchor:SetPoint("CENTER", UIParent, "CENTER", db.xOfs, db.yOfs)
end

function addon:ToggleAnchor()
	if MosphetCookies.CenterText.anchor:IsShown() then
		MosphetCookies.CenterText.anchor:Hide()
		MosphetCookies.CenterText:SetTimeVisible(2)
	else
		MosphetCookies.CenterText.anchor:Show()
		MosphetCookies.CenterText:SetTimeVisible(999999)
		if not combat then
			MosphetCookies.CenterText:AddMessage("AiS: 1.234\nSS: 1.234\nCoS: 1.234\n"..L["Haste"]..": 1234\n"..L["Haste"]..": 12.34%\nPet AP: 1234\n"..L["Rabid"]..": 0", 0.6, 0.7, 1, 1)
		end
	end
end

function addon:SlashHandler(command)
	command = self:Explode(" ", string.lower(command))
	if(command[1] == "lock") then
		self:ToggleAnchor()
	elseif(command[1] == "reset") then
		self:ResetAnchor()
		self:print(L["Position Reset"])
	elseif(command[1] == "debug") then
		if (debug) then
			debug = nil
		else
			debug = true
		end
	elseif(command[1] == "help") then
		self:print("|cFFFFCC00"..L["MosphetCookies help commands"].."|r:")
		self:print("|cFFCC9900   lock|r - "..L["Toggle the anchor lock"])
		self:print("|cFFCC9900   reset|r - "..L["Resets the frame position"])
		self:print("|cFFCC9900   debug|r - "..L["Enable/Disable Debug"])
	else
		self.Options:ToggleConfig()
	end
end

function addon:Explode(d, str)
	local t, ll
	t = {}
	ll = 0
	if(#str == 1) then return str end
		while true do
			local l = strfind(str, d, ll+1, true)
			if l~=nil then
				tinsert(t, strsub(str, ll, l-1))
				ll=l+1
			else
				tinsert(t, strsub(str,ll))
				break
			end
		end
	return t
end